
/*Simulazione dei sistemi di modulazione impiegati nella trasmissione di segnali
analogici e digitali*/
#include<stdio.h>
#include<conio.h>
#include<graphics.h>
#include<math.h>
#include<bios.h>
#include<stdlib.h>
#include<string.h>
#include<graphics.h>

void ONDA_QUADRA(void);
void ONDA_TRIANGOLARE(void);
void IMPULSI_RETTANGOLARI(void);
void SINUSOIDE_RADDRIZZATA_A_SEMIONDA(void);
void SINUSOIDE_RADDRIZZATA_AD_ONDA_INTERA(void);
void ONDA_A_DENTE_DI_SEGA(void);

void reticoloyt(void);
void reticoloyf(void);


int scelta,driver,mode,color,N,ampx,ampy,nline;
int xint,yint,i,ordine,somma_ordinate[1000];
float x,y,A,F,coefficienti[10],passox,passoy,n,DC,coeffrect,p;
main()
{
clrscr();
printf("\n");
printf("\n");
printf("\n");
printf("                         ANALISI SPETTRALE\n");
printf("\n");
printf("\n");
printf("\n");
printf("                  AUTORE:PROF. ANTONINO CUCINOTTA\n");
printf("                  I.T.I.S. MAJORANA  -  MILAZZO\n");
printf("\                        A.S. 2009/2010\n");
printf("                  Premere ENTER per continuare\n");
getch();
clrscr();
do{
printf ("SEGNALE DI CUI SI DESIDERA EFFETTUARE L'ANALISI SPETTRALE\n");
printf("\n");
printf(" ONDA QUADRA........................................Digitare 1\n");
printf("\n");
printf("\n");
printf(" ONDA TRIANGOLARE...................................Digitare 2\n");
printf("\n");
printf("\n");
printf(" IMPULSI RETTANGOLARI...............................Digitare 3\n");
printf("\n");
printf("\n");
printf(" SINUSOIDE RADDRIZZATA A SEMIONDA (N=10 armoniche)..Digitare 4\n");
printf("\n");
printf(" SINUSOIDE RADDRIZZATA AD ONDA INTERA...............Digitare 5\n");
printf("\n");
printf(" ONDA A DENTE DI SEGA...............................Digitare 6\n");
printf("\n");
printf("\n");
printf("                  Digitare 0 per uscire dal programma.\n");
printf("                  Premere ENTER per interrompere una procedura\n");
printf("                  e ritornare al menu\n");
scanf("%d",&scelta);
switch(scelta){
	   case  1:ONDA_QUADRA();
	   break;
	   case  2:ONDA_TRIANGOLARE();
	   break;
	   case	 3:IMPULSI_RETTANGOLARI();
	   break;
	   case	 4:SINUSOIDE_RADDRIZZATA_A_SEMIONDA();
	   break;
	   case  5:SINUSOIDE_RADDRIZZATA_AD_ONDA_INTERA();
	   break;
	   case  6:ONDA_A_DENTE_DI_SEGA();
	   break;
	      }
    }while(scelta!= 0);
}

void ONDA_QUADRA()
{
  clrscr();
  textmode(BW80);
  textbackground(0);
  printf("Ampiezza  A (<=20) =");
  scanf("%f",&A);
  printf("Numero di periodi(<=10) =");
  scanf("%f",&p);
  printf("\n");
  printf("\n");
  printf("Ordine massimo delle armoniche N =");
  scanf("%d",&N);
  printf("\n");
  driver=9;
  mode=2;
  /*VGALO:mode=0,640x200/VGAMED:mode=1,640x350/VGAHI:mode=2,640x480*/
  initgraph(&driver,&mode," ");
  setbkcolor(0);
  ampx=640;
  ampy=480;
    for(i=0;i<=0.8*ampx;i++) somma_ordinate[i]=0;
    reticoloyt();
    setcolor(2);
    n=1;
	   do
	    {
	     for(i=0;i<=(0.8*ampx);i++)
	      {
	      y = 0.7*ampy/2 - (0.7*ampy/2)*(4*A/(n*3.14) )*(1/20.0)*sin(2*3.14*n*i/(0.8*ampx/p));
	      yint=(int)y;
	      putpixel(i,yint,color);
	      somma_ordinate[i]=somma_ordinate[i] + yint;
		}
	    n=n+2;
	    color=color+1;
	      getch();
		    }while (n<=N);

	      getch();
	      cleardevice();
	      reticoloyt();
for(i=0;i<=0.8*ampx;i++)
	      {
	      somma_ordinate[i]=somma_ordinate[i] - ((N-1)/2)*0.7*ampy/2;
	      putpixel(i,somma_ordinate[i],WHITE);
	      putpixel(i+1,somma_ordinate[i],WHITE);
	      putpixel(i,somma_ordinate[i],WHITE);
	      }
getch();
cleardevice();
reticoloyf();
setcolor(YELLOW);
n=1;
do
{
line((int)(n*0.8*ampx/N),(int)(0.7*ampy),(int)(n*0.8*ampx/N),(int)(0.7*ampy*(1.0-A/(20.0*n)) ));
line((int)(1+n*0.8*ampx/N),(int)(0.7*ampy),(int)(1+n*0.8*ampx/N),(int)(0.7*ampy*(1.0-A/(20.0*n)) ));
n=n+2;
}while(n<=N);
getch();
cleardevice();
restorecrtmode();
}

void ONDA_TRIANGOLARE()
{
  clrscr();
  textmode(BW80);
  textbackground(0);
  printf("Ampiezza  A (<=20) =");
  scanf("%f",&A);
  printf("\n");
  printf("Ordine massimo delle armoniche N =");
  scanf("%d",&N);
  printf("\n");
  printf("Numero di periodi (<=10) =");
  scanf("%f",&p);
  driver=9;
  mode=2;
  /*VGALO:mode=0,640x200/VGAMED:mode=1,640x350/VGAHI:mode=2,640x480*/
  initgraph(&driver,&mode," ");
  setbkcolor(0);
  ampx=640;
  ampy=480;
    for(i=0;i<=0.8*ampx;i++) somma_ordinate[i]=0;
    reticoloyt();
    setcolor(2);
    n=1;
	   do
	    {
	     for(i=0;i<=(0.8*ampx);i++)
	      {
	      y = 0.7*ampy/2 - (0.7*ampy/2)*(8*A*sin(n*3.14/2.0)/(n*n*9.859))*(1/20.0)*sin(2*3.14*n*i/(0.8*ampx/p));
	      yint=(int)y;
	      putpixel(i,yint,color);
	      somma_ordinate[i]=somma_ordinate[i] + yint;
		}
	    n=n+2;
	    color=color+1;
	      getch();
		    }while (n<=N);

	      getch();
	      cleardevice();
	      reticoloyt();
for(i=0;i<=0.8*ampx;i++)
	      {
	      somma_ordinate[i]=somma_ordinate[i] - ((N-1)/2)*0.7*ampy/2;
	      putpixel(i,somma_ordinate[i],WHITE);
	      putpixel(i+1,somma_ordinate[i],WHITE);
	      putpixel(i,somma_ordinate[i],WHITE);
	      }
getch();
cleardevice();
reticoloyf();
setcolor(YELLOW);
n=1;
do
{
line((int)(n*0.8*ampx/N),(int)(0.7*ampy),(int)(n*0.8*ampx/N),(int)(0.7*ampy*(1.0-A/(20.0*n)) ));
line((int)(1+n*0.8*ampx/N),(int)(0.7*ampy),(int)(1+n*0.8*ampx/N),(int)(0.7*ampy*(1.0-A/(20.0*n)) ));
n=n+2;
}while(n<=N);
getch();
cleardevice();
restorecrtmode();
}



void IMPULSI_RETTANGOLARI()
{
  clrscr();
  textmode(BW80);
  textbackground(0);
  printf("Ampiezza  A (<=20) =");
  scanf("%f",&A);
  printf("\n");
  printf("Duty Cycle (%) =");
  scanf("%f",&DC);
  printf("\n");
  printf("Ordine massimo delle armoniche N =");
  scanf("%d",&N);
    printf("Numero di periodi (<=10) =");
  scanf("%f",&p);
  printf("\n");
  driver=9;
  mode=2;
  /*VGALO:mode=0,640x200/VGAMED:mode=1,640x350/VGAHI:mode=2,640x480*/
  initgraph(&driver,&mode," ");
  setbkcolor(0);
  ampx=640;
  ampy=480;
    for(i=0;i<=0.8*ampx;i++) somma_ordinate[i]=A*DC*0.01;
    reticoloyt();
    setcolor(2);
    n=1;
	   do
	    {
	     for(i=0;i<=(0.8*ampx);i++)
	      {
	      coeffrect=2*(A/20.0)*DC*0.01*sin(n*3.14*DC*0.01)/(n*3.14*DC*0.01);
	      y = 0.7*ampy/2 - (0.7*ampy/2)*coeffrect*cos(2*3.14*n*i/(0.8*ampx/p));
	      yint=(int)y;
	      putpixel(i,yint,color);
	      somma_ordinate[i]=somma_ordinate[i] + yint;
	      }
	    n=n+1;
	    color=color+1;
	      getch();
		    }while (n<=N);

	      getch();
	      cleardevice();
	      reticoloyt();
for(i=0;i<=0.8*ampx;i++)
	      {
	      somma_ordinate[i]=somma_ordinate[i] - (N-1)*0.7*ampy/2;
	      putpixel(i,somma_ordinate[i],WHITE);
	      putpixel(i+1,somma_ordinate[i],WHITE);
	      putpixel(i,somma_ordinate[i],WHITE);
	      }
getch();
cleardevice();
reticoloyf();
setcolor(YELLOW);
line(0,(int)(0.7*ampy),0,(int)(0.7*ampy*(1-(A/20.0)*DC*0.01)) );
n=1;
do
{
coeffrect=2*(A/20.0)*DC*0.01*fabs(sin(n*3.14*DC*0.01))/(n*3.14*DC*0.01);
line((int)(n*0.8*ampx/N),(int)(0.7*ampy),(int)(n*0.8*ampx/N),(int)(0.7*ampy*(1.0 - coeffrect)));
line((int)(1+n*0.8*ampx/N),(int)(0.7*ampy),(int)(1+n*0.8*ampx/N),(int)(0.7*ampy*(1.0 - coeffrect)));
n=n+1;
}while(n<=N);
getch();
cleardevice();
restorecrtmode();
}

void SINUSOIDE_RADDRIZZATA_A_SEMIONDA()
{
  clrscr();
  textmode(BW80);
  textbackground(0);
  printf("Ampiezza  A (<=20) =");
  scanf("%f",&A);
  printf("\n");
  printf("Ordine massimo delle armoniche N =");
  scanf("%d",&N);
  printf("\n");
    printf("Numero di periodi (<=10) =");
  scanf("%f",&p);
  driver=9;
  mode=2;
  /*VGALO:mode=0,640x200/VGAMED:mode=1,640x350/VGAHI:mode=2,640x480*/
  initgraph(&driver,&mode," ");
  setbkcolor(0);
  ampx=640;
  ampy=480;
    for(i=0;i<=0.8*ampx;i++) somma_ordinate[i] = 0.7*ampy/2*(1 - A/(20*3.14) - (A/(20*2))*sin(2*3.14*i/(0.8*ampx/p)));
    reticoloyt();
    setcolor(2);
    n=2;i=0;
	   do
	    {
	     for(i=0;i<=(0.8*ampx);i++)
	      {
	      y = 0.7*ampy/2 - (0.7*ampy/2)*(1 + pow(-1,n))*(A/(20*3.14*(1-n*n)) )*cos(2*3.14*n*i/(0.8*ampx/p));
	      yint=(int)y;
	      putpixel(i,yint,color);
	      somma_ordinate[i]=somma_ordinate[i] + yint;
		}
	    n=n+1;
	    color=color+1;
	      getch();
		    }while (n<=N);

	      getch();
	      cleardevice();
	      reticoloyt();
for(i=0;i<=0.8*ampx;i++)
	      {
	      somma_ordinate[i]=somma_ordinate[i] - (9)*0.7*ampy/2 ;
	      putpixel(i,somma_ordinate[i],WHITE);
	      putpixel(i+1,somma_ordinate[i],WHITE);
	      putpixel(i,somma_ordinate[i],WHITE);
	      }
getch();
cleardevice();
reticoloyf();
setcolor(YELLOW);
line(0,(int)(0.7*ampy),0,(int)(  0.7*ampy*(1- A/(20*3.14) ))  );
line((int)(0.8*ampx/N),(int)(0.7*ampy),(int)(0.8*ampx/N),(int)(0.7*ampy*(1- A/(20.0*2) )  ) );
n=2;
do
{
line((int)(n*0.8*ampx/N),(int)(0.7*ampy),(int)(n*0.8*ampx/N),(int)( 0.7*ampy*(1-(2*A/(20*3.14*(n*n-1))))) );
line((int)(1+n*0.8*ampx/N),(int)(0.7*ampy),(int)(1+n*0.8*ampx/N),(int)(0.7*ampy*(1-(2*A/(20*3.14*(n*n-1))))) );
n=n+2;
}while(n<=N);
getch();
cleardevice();
restorecrtmode();
}

void SINUSOIDE_RADDRIZZATA_AD_ONDA_INTERA(void)
{
  clrscr();
  textmode(BW80);
  textbackground(0);
  printf("Ampiezza  A (<=20) =");
  scanf("%f",&A);
  printf("\n");
  printf("Ordine massimo delle armoniche N =");
  scanf("%d",&N);
  printf("\n");
  printf("Numero di periodi (<=10) =");
  scanf("%f",&p);
  driver=9;
  mode=2;
  /*VGALO:mode=0,640x200/VGAMED:mode=1,640x350/VGAHI:mode=2,640x480*/
  initgraph(&driver,&mode," ");
  setbkcolor(0);
  ampx=640;
  ampy=480;
    for(i=0;i<=0.8*ampx;i++) somma_ordinate[i] = (0.7*ampy/2)*(1 - 2*A/(20*3.14));
    reticoloyt();
    setcolor(2);
    n=1;i=0;
	   do
	    {
	     for(i=0;i<=(0.8*ampx);i++)
	      {
	      y = 0.7*ampy/2 - (0.7*ampy/2)*( 4*A*pow(-1,n)/(3.14*(1-4*n*n)) )*(1/20.0)*cos(2*3.14*n*i/(0.8*ampx/p));
	      yint=(int)y;
	      putpixel(i,yint,color);
	      somma_ordinate[i]=somma_ordinate[i] + yint;
	      }
	    n=n+1;
	    color=color+1;
	      getch();
	    } while (n<=N);

	      getch();
	      cleardevice();
	      reticoloyt();
for(i=0;i<=0.8*ampx;i++)
	      {
	      somma_ordinate[i]=somma_ordinate[i] - N*0.7*ampy/2.0 ;
	      putpixel(i,somma_ordinate[i],WHITE);
	      putpixel(i+1,somma_ordinate[i],WHITE);
	      putpixel(i,somma_ordinate[i],WHITE);
	      }
getch();
cleardevice();
reticoloyf();
setcolor(YELLOW);
line(0,(int)(0.7*ampy),0,(int)(  0.7*ampy*(1-2*A/(3.14*20))  ) );
n=1;
do
{
line((int)(n*0.8*ampx/N),(int)(0.7*ampy),(int)(n*0.8*ampx/N),(int)(0.7*ampy*(1 - fabs(4*(A/20.0)/( 3.14*(1.0-4*n*n))) )  )  );
line((int)(1+n*0.8*ampx/N),(int)(0.7*ampy),(int)(1+n*0.8*ampx/N),(int)(0.7*ampy*(1 - fabs(4*(A/20.0)/( 3.14*(1.0-4*n*n)))  )  )  );
n=n+1;
}while(n<=N);
getch();
cleardevice();
restorecrtmode();
}



void ONDA_A_DENTE_DI_SEGA()
{
  clrscr();
  textmode(BW80);
  textbackground(0);
  printf("Ampiezza  A (<=20) =");
  scanf("%f",&A);
  printf("\n");
  printf("Ordine massimo delle armoniche N =");
  scanf("%d",&N);
  printf("\n");
  printf("Numero di periodi (<=10)=");
  scanf("%f",&p);
  driver=9;
  mode=2;
  /*VGALO:mode=0,640x200/VGAMED:mode=1,640x350/VGAHI:mode=2,640x480*/
  initgraph(&driver,&mode," ");
  setbkcolor(0);
  ampx=640;
  ampy=480;
    for(i=0;i<=0.8*ampx;i++) somma_ordinate[i]=0;
    reticoloyt();
    setcolor(2);
    n=1;
	   do
	    {
	     for(i=0;i<=(0.8*ampx);i++)
	      {
	      y = 0.7*ampy/2 - (0.7*ampy/2)*(2*A*pow(-1,n+1)/(n*3.14))*(1/20.0)*sin(2*3.14*n*i/(0.8*ampx/p));
	      yint=(int)y;
	      putpixel(i,yint,color);
	      somma_ordinate[i]=somma_ordinate[i] + yint;
	      }
	    n=n+1;
	    color=color+1;
	      getch();
	    }while (n<=N);

	      getch();
	      cleardevice();
	      reticoloyt();
for(i=0;i<=0.8*ampx;i++)
	      {
	      somma_ordinate[i]=somma_ordinate[i] - (N-1)*0.7*ampy/2;
	      putpixel(i,somma_ordinate[i],WHITE);
	      putpixel(i+1,somma_ordinate[i],WHITE);
	      putpixel(i,somma_ordinate[i],WHITE);                                              	      }
getch();
cleardevice();
reticoloyf();
setcolor(YELLOW);
n=1;
do
{
line((int)(n*0.8*ampx/N),(int)(0.7*ampy),(int)(n*0.8*ampx/N),(int)(0.7*ampy*(1.0-A/(20.0*n)) ));
line((int)(1+n*0.8*ampx/N),(int)(0.7*ampy),(int)(1+n*0.8*ampx/N),(int)(0.7*ampy*(1.0-A/(20.0*n)) ));
n=n+2;
}while(n<=N);
getch();
cleardevice();
restorecrtmode();
}




void reticoloyt()
{
color=LIGHTGREEN;
setviewport(0.1*ampx,0.2*ampy,0.9*ampx,0.9*ampy,1);
setbkcolor(BLACK);
for (nline=0;nline<=N;nline++)
    {
     passox=0.8*ampx/N;
     passoy=0.7*ampy/N;
     if(nline==0 || nline==N) setcolor(color+2);
     else setcolor(color);
     line((int)(nline*passox),0,(int)(nline*passox),0.7*ampy);
     line(0,(int)(nline*passoy),0.8*ampx,(int)(nline*passoy));
    }
line(0,(int)(passoy*N/2.0),0.8*ampx,(int)(passoy*N/2.0));
}


void reticoloyf()
{
color=LIGHTGREEN;
setviewport(0.1*ampx,0.2*ampy,0.9*ampx,0.9*ampy,1);
setbkcolor(BLACK);
for (nline=0;nline<=N;nline++)
    {
     passox=0.8*ampx/N;
     passoy=0.7*ampy/N;
     if(nline==0 || nline==N) setcolor(color+2);
     else setcolor(color);
     line((int)(nline*passox),0,(int)(nline*passox),0.7*ampy);
     line(0,(int)(nline*passoy),0.8*ampx,(int)(nline*passoy));
    }
}
